﻿#region System Namespace
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.IO;
using System.Threading;
#endregion System Namespace

#region Foreign Namespace
#endregion Foreign Namespace

#region Styx Namespace
using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.Common;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
#endregion Styx Namespace


namespace declineAll
{
    public class declineAll : HBPlugin
    {
        public int _MinTime = 2000; //minimum and
        public int _MaxTime = 5000; //maximum time before decline

        private Stopwatch _Timer1 = new Stopwatch();
        private Stopwatch _Timer2 = new Stopwatch();
        private Stopwatch _Timer3 = new Stopwatch();
        private Stopwatch _Timer4 = new Stopwatch();
        public bool _GuildInvited = false;
        public bool _PartyInvited = false;
        public bool _TradeRequest = false;
        public bool _DuelRequest = false;
        public int _RandomTime = 0;
        private bool _FirstStart = true;

        public override void Pulse()
        {
            if (_FirstStart)
            {
                Lua.Events.AttachEvent("GUILD_INVITE_REQUEST", _CheckGuild);
                Lua.Events.AttachEvent("PARTY_INVITE_REQUEST", _CheckParty);
                Lua.Events.AttachEvent("TRADE_SHOW", _CheckTrade);
                Lua.Events.AttachEvent("DUEL_REQUESTED", _CheckDuel);
                _FirstStart = false;
            }

            if (_GuildInvited && _Timer1.ElapsedMilliseconds >= _RandomTime)
            {
                Lua.DoString("DeclineGuild()");
                Lua.DoString("StaticPopup_Hide(\"GUILD_INVITE\")");
                _GuildInvited = false;
            }

            if (_PartyInvited && _Timer2.ElapsedMilliseconds >= _RandomTime)
            {
                Lua.DoString("DeclineGroup()");
                Lua.DoString("StaticPopup_Hide(\"PARTY_INVITE\")");
                _PartyInvited = false;
            }

            if (_TradeRequest && _Timer3.ElapsedMilliseconds >= _RandomTime)
            {
                Lua.DoString("CancelTrade()");
                _PartyInvited = false;
            }

            if (_DuelRequest && _Timer4.ElapsedMilliseconds >= _RandomTime)
            {
                Lua.DoString("CancelDuel()");
                Lua.DoString("StaticPopup_Hide(\"DUEL_REQUESTED\")");
                _DuelRequest = false;
            }
        }

        public void _CheckGuild(object sender, LuaEventArgs args)
        {
            _Timer1.Reset();
            _Timer1.Start();
            _RandomTime = RandomNumber(_MinTime, _MaxTime);
            _GuildInvited = true;
            Logging.Write("Cuimai提醒:检测到公会邀请" + _RandomTime / 1000 + "秒后自动拒绝");
        }

        public void _CheckParty(object sender, LuaEventArgs args)
        {
            _Timer2.Reset();
            _Timer2.Start();
            _RandomTime = RandomNumber(_MinTime, _MaxTime);
            _PartyInvited = true;
            Logging.Write("Cuimai提醒:检测到组队邀请 " + _RandomTime / 1000 + "秒后自动拒绝");
        }

        public void _CheckTrade(object sender, LuaEventArgs args)
        {
            _Timer3.Reset();
            _Timer3.Start();
            _RandomTime = RandomNumber(_MinTime, _MaxTime);
            _TradeRequest = true;
            Logging.Write("Cuimai提醒:检测到交易请求 " + _RandomTime / 1000 + "秒后自动拒绝");
        }

        public void _CheckDuel(object sender, LuaEventArgs args)
        {
            _Timer4.Reset();
            _Timer4.Start();
            _RandomTime = RandomNumber(_MinTime, _MaxTime);
            _DuelRequest = true;
            Logging.Write("Cuimai提醒:检测到决斗邀请 " + _RandomTime / 1000 + "秒后自动拒绝");
        }

        private int RandomNumber(int min, int max)
        {
            Random random = new Random();
            return random.Next(min, max);
        }

        public override string Name { get { return "【自动拒绝组队、工会、战斗、交易】"; } }

        public override string Author { get { return "Bryt"; } }

        public override Version Version { get { return new Version(1, 0); } }
    }
}